#!/bin/sh
# Usage: sh install

dest=/root/linux

echo "Installing viva version 2.0 for Linux 2.0.0..."

# First copy viva include files
cp include/* $dest/include/linux

# Create viva directory and copy viva source code
mkdir $dest/fs/viva
cp src/* $dest/fs/viva

# Apply patch for fs.h
patch $dest/include/linux/fs.h < ./viva.include.patch

# Apply patches to files in the $dest/fs directory
patch $dest/fs/Makefile < patch/viva.Makefile.patch
patch $dest/fs/filesystems.c < patch/viva.filesystems.patch
# Patch to include VIVA when the kernel is compiled
patch $dest/fs/Config.in < patch/viva.config.patch

echo "Compile and install utilities from the utils directory"

echo "Installation complete."
echo "Before you recompile the kernel, you should read the README.viva file"
echo " "
echo "Viva - version 2.0, July 1996"
echo "Authors: Shankar Pasupathy (shankar@dcs.uky.edu)"
echo "         and Vamsi Krishna (vamsi@cslab.uky.edu)"
echo "Viva was designed by Eric Herrin II and Raphael Finkel"
echo "University of Kentucky, Lexington, KY 40506"
echo "Distributed under the GNU copyleft"

