/* -----------------------------------------------------------------
The VIVA file system - version 2.0

Implemented by Shankar Pasupathy, July 1996. (shankar@pop.uky.edu)
Modified by Vamsi Krishna, July 1997. (vamsi@cslab.uky.edu)
VIVA was developed by Eric Herrin II and Raphael Finkel.
Department of Computer Science,
University of Kentucky, Lexington 40506.
Distribution site: http://www.cslab.uky.edu/~vamsi/viva

This implementation uses code from the Minix filesystem,
(Copyright: Linus Torvalds).

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation. Read the file COPYRIGHT, included with
this distribution, for further details.
--------------------------------------------------------------------*/
/* Viva can't handle a hole like tradition file systems do i.e. store
a null pointer in the disk address field. When a process does an lseek
past the end of a file, we allocate one or more 0-filled blocks. */

#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/viva_fs.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/string.h>
#include <linux/stat.h>
#include <linux/locks.h>
#include <asm/system.h>
#include <asm/segment.h>

long viva_lseek(struct inode *inode, struct file *file,off_t offset,int origin)
{
int block_nr, b_num;
int num_blocks;
off_t tmp=-1;

switch (origin) {
	case 0:
		tmp = offset;
		break;
	case 1:
		tmp = file->f_pos + offset;
		break;
	case 2:
		if (!file->f_inode)
			return -EINVAL;
		tmp = file->f_inode->i_size + offset;
			break;
	}
if (tmp < 0)
	return -EINVAL;
if (tmp > (file->f_inode->i_size-1)) 
{
	block_nr = file->f_inode->i_size/VIVA_BLOCK_SIZE;

/*
	for (b_num=0;b_num<((tmp/VIVA_BLOCK_SIZE)-(file->f_inode->i_size/VIVA_BLOCK_SIZE));b_num++)
	{
		struct buffer_head *bh;
		bh = viva_getblk(file->f_inode,block_nr,1);

		if(bh)
		{
			mark_buffer_dirty(bh,0);
			brelse(bh);
		}
		block_nr++;
	}
*/

	num_blocks =(tmp/VIVA_BLOCK_SIZE)-(block_nr)-1;
	if( !(file->f_inode->i_size%VIVA_BLOCK_SIZE) || !(tmp%VIVA_BLOCK_SIZE) )
		num_blocks++;
/*	printk("Vamsi: Lseek from %d (%d) to %d (%d) for %d blocks \n", file->f_inode->i_size/VIVA_BLOCK_SIZE, file->f_inode->i_size, tmp/VIVA_BLOCK_SIZE, tmp, num_blocks);*/
	if(num_blocks > 0)
		viva_add_hole(file->f_inode,num_blocks);
/*	printk("%d, block_nr = %d (%d)\n",file->f_inode->i_size,block_nr,b_num);*/
	file->f_inode->i_size = tmp;
}

if (tmp != file->f_pos) {
		file->f_pos = tmp;
		file->f_reada = 0;
		file->f_version = ++event;
	}
return file->f_pos;
}
